using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace FormulaEngineDefect
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            InitializeGrid();
        }
        private void InitializeGrid()
        {
            gridControl1.SaveCellInfo += new GridSaveCellInfoEventHandler(gridControl1_SaveCellInfo);
            gridControl1.CellModels.Add("SyncDouble", new SyncDouble(gridControl1.Model));

            GridStyleInfo[] styles = gridControl1.GetCellsInfo(gridControl1.GridCellsRange);
            for (int row = 1; row <= gridControl1.GridCellsRange.Bottom; row++)
            {
                for (int col = 1; col <= gridControl1.GridCellsRange.Right; col++)
                {
                    GridStyleInfo newStyle = new GridStyleInfo();
                    //add custom property
                    SyncStyleProperties sp = new SyncStyleProperties(newStyle);
                    Person p = new Person();
                    p.FirstName = "Bob";
                    p.FirstName = "Dobalina";
                    sp.Person = p;
                    newStyle.CellType = "SyncDouble";
                    
                    gridControl1.Data[row, col] = newStyle.Store;
                }
            }
            gridControl1[3, 2].Text = @"Copy this formula refering to D3 '=D3' >>>";
            gridControl1[4, 2].Text = @"Pasting here should give the formula'=D4' >>>";
            gridControl1[3, 3].Text = @"=D3";
            gridControl1[3, 4].Text = @"1";
            gridControl1[4, 4].Text = @"2";
            Debug.WriteLine(" 4,4 celltype = " + gridControl1[4, 4].CellType);

            GridFormulaEngine engine = ((GridFormulaCellModel)gridControl1.CellModels["FormulaCell"]).Engine;

            engine.FormulaCopyFlags = GridFormulaCopyFlags.ClipBoardFormula |
                                        GridFormulaCopyFlags.ClipBoardReferencesAdjusted |
                                        GridFormulaCopyFlags.InsDelRangeReferencesUpdated |
                                        GridFormulaCopyFlags.NamedRangeReferencesUpdated;


            engine = ((GridFormulaCellModel)gridControl1.CellModels["SyncDouble"]).Engine;

            engine.FormulaCopyFlags = GridFormulaCopyFlags.ClipBoardFormula |
                                        GridFormulaCopyFlags.ClipBoardReferencesAdjusted |
                                        GridFormulaCopyFlags.InsDelRangeReferencesUpdated |
                                        GridFormulaCopyFlags.NamedRangeReferencesUpdated;

        }

        void gridControl1_SaveCellInfo(object sender, GridSaveCellInfoEventArgs e)
        {
            Debug.WriteLine(e.Style.CellType);
        }

        private void gridControl1_CellClick(object sender, GridCellClickEventArgs e)
        {

        }
    }
}